<?php
function _usort_abc_archetype ( $a, $b, $order = 1 ) {
 static $abc123 = '0123456789abcdefghijklmnopqrstuvwxyz';
 if (is_numeric ($a) && is_numeric ($b)) {
  return $a == $b ? 0 : ($a < $b ? -1 : 1);
 }
 return ($a == $b ? 0 : (!stristr ($abc123, $a{0}) || !stristr ($abc123, $b{0}) || stripos ($abc123, $a{0}) < stripos ($abc123, $b{0}) ? $order*-1 : $order*1));
}

function _usort_abc ( $a, $b ) {
 return _usort_abc_archetype ($a, $b, 1);
}

function _usort_zyx ( $a, $b ) {
 return _usort_abc_archetype ($a, $b, -1);
}

function _array_walk_trim ( &$v, &$k ) {
 if (is_array ($v)) {
  array_walk ($v, '_array_walk_trim');
 } else {
  $v = trim ($v);
 }
}

function get_type ( $perm_str, $return_filetype = false, $file_ext = false ) {
 global $_MIME;
 switch ($perm_str{0}) {
  case 'd':
   return 'directory';
  case 'l':
   return 'link';
  case '-':
   if ($return_filetype && $file_ext) {
    foreach ($_MIME as $type => $ext) {
     if ($ext && preg_match ('#'.$ext.'#i', $file_ext)) {
      return substr ($type, 0, strpos ($type, '/'));
     }
    }
    return 'file';
   } else {
    return 'file';
   }
 }
 return false;
}

function format_bytes ( $bytes ) {
 if ($bytes >= 1099511627776) {
  $bytes = round ($bytes/1099511627776, 2);
  $type  = 'TB';
 } elseif ($bytes >= 1073741824) {
  $bytes = round ($bytes/1073741824, 2);
  $type  = 'GB';
 } elseif ($bytes >= 1048576) {
  $bytes = round ($bytes/1048576, 2);
  $type  = 'MB';
 } elseif ($bytes >= 1024) {
  $bytes = round ($bytes/1024, 2);
  $type  = 'KB';
 } elseif ($bytes < 1024) {
  $type = 'B';
 }
 return $bytes . ' ' . $type;
}

function shade ( ) {
 static $i;
 return ' class="cell'.(((int)(bool)($i++ & 1))+1).'"';
}

function foot ( $msg = '' ) {
 exit (vsprintf ('%s  <div id="foot">FTPhp Manager v1.0 &copy; 2004 <a href="mailto:webmaster(at symbol)script(dash)tease(period)net">Onion</a><br />Script executed in %.3f seconds.</div>%c </body>%c</html>', array ("$msg\n", microtime (1) - START, 10, 10)));
}
