<?php
ob_start ();

require_once './inc/config.inc';
require_once './inc/class.ftp.inc';
require_once './inc/functions.inc';

if (isset ($_POST['host'], $_POST['port'], $_POST['user'], $_POST['pass']) && (empty ($_HOSTS) || in_array ($_POST['host'], $_HOSTS))) {
 $_SESSION['host'] = $_POST['host'];
 $_SESSION['port'] = $_POST['port'] ? (int) $_POST['port'] : 21;
 $_SESSION['user'] = $_POST['user'] ? $_POST['user']       : 'anonymous';
 $_SESSION['pass'] = $_POST['pass'] ? $_POST['pass']       : 'root@localhost';
 $_SESSION['path'] = null;
}

if (isset ($_SERVER['HTTP_ACCEPT']) && stristr ($_SERVER['HTTP_ACCEPT'], 'application/xhtml+xml')) {
 header ('Content-Type: application/xhtml+xml; charset=iso-8859-1');
} else {
 header ('Content-Type: text/html; charset=iso-8859-1');
}

echo '<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
 <head>
  <title>FTPhp Manager</title>
  <link rel="stylesheet" type="text/css" title="Default Stylesheet" href="inc/style.css" />
 </head>
 <body>
  <h1>FTPhp Manager</h1>',"\n";

if (isset ($_SESSION['host'], $_SESSION['port'], $_SESSION['user'], $_SESSION['pass'])) {
 $ftp = new FTP ($_SESSION['host'], $_SESSION['port'], $_SESSION['user'], $_SESSION['pass']);
 if ($ftp->last_error_msg) {
  echo '  <div class="error">',$ftp->last_error_msg,'</div>',"\n";
  unset ($ftp);
 }
} 

echo '  <form action="',$_SERVER['PHP_SELF'],'" method="post">
   <table id="menubar">
    <tbody>
     <tr>
      <th>Address: ';
if (count ($_HOSTS)) {
 echo '
       <select name="host">',"\n";
 foreach ($_HOSTS as $host) {
  echo '        <option value="',$host,'">',$host,'</option>',"\n";
 }
 echo '       </select>',"\n",'      ';
} else {
 echo '<input type="text" size="25" name="host" value="',isset ($_SESSION['host']) ? $_SESSION['host'] : '','" />';
}

echo '</th>
      <th>Port: <input type="text" size="5" name="port" value="',isset ($_SESSION['port']) ? $_SESSION['port'] : '21','" /></th>
      <th>User: <input type="text" size="25" name="user" value="',isset ($_SESSION['user']) ? $_SESSION['user'] : '','" /></th>
      <th>Password: <input type="password" size="25" name="pass" value="',isset ($_SESSION['pass']) ? $_SESSION['pass'] : '','" /></th>
      <th><input type="submit" value="Connect" /></th>
     </tr>
    </tbody>
   </table>
  </form>',"\n";

if (!isset ($ftp) || !is_object ($ftp)) {
 foot ();
}

if (isset ($_GET['delete']) && !$ftp->dele ($_GET['delete'])) {
 echo '  <div class="error">',$ftp->get_last_response_str (),'</div>',"\n";
}

if (isset ($_GET['rmd']) && !$ftp->rmd ($_GET['delete'])) {
 echo '  <div class="error">',$ftp->get_last_response_str (),'</div>',"\n";
}

if (isset ($_GET['path']) && !$ftp->cwd ($_GET['path'])) {
 echo '  <div class="error">',$ftp->get_last_response_str (),'</div>',"\n";
}

if (isset ($_POST['mkdir']) && !$ftp->mkd ($_POST['mkdir'])) {
 echo '  <div class="error">',$ftp->get_last_response_str (),'</div>',"\n";
}

if (isset ($_GET['download'])) {
 $file_contents = $ftp->retr ($_GET['download']);
 if ($file_contents === false) {
  echo '  <div class="error">',$ftp->get_last_response_str (),'</div>',"\n";
 } else {
  ob_clean ();
  echo $file_contents;
  header ('Content-Type: application/octet_stream');
  header ('Content-Disposition: attachment; filename="'.(end (explode ('/', $_GET['download']))).'"');
  header ('Content-Length: '.strlen (ob_get_contents ()));
  exit;
 }
}

if (isset ($_POST['upload']) && !empty ($_FILES)) {
 $i = 0;
 foreach ($_FILES as $file) {
  if ($i++ > 2) {
   break;
  }
  if ($file['error'] != 0) {
   continue;
  }
  if (!$ftp->stor ($file['tmp_name'], $file['name'])) {
   echo '  <div class="error">',$ftp->get_last_response_str (),'</div>',"\n";
  }
 }
}

$pwd = $ftp->pwd ();

//                 Permissions      dunno owner   group   size        date               name
//                       1                  2        3      4           5                 6
preg_match_all ('#([\-dlwrx]{10})\s+\d+\s+(.+)\s+(.+)\s+(\d+)\s+(\w+\s+\w+\s+[\w\:]+)\s+(.+?)#Ui', $ftp->ls (), $sorted_list, PREG_PATTERN_ORDER);
array_walk (&$sorted_list, '_array_walk_trim');
reset ($sorted_list);

switch (isset ($_GET['sort']) ? $_GET['sort'] : 'filename') {
 default: 
 case 'filename':    $index = 6; $sort = 'filename';    break;
 case 'filesize':    $index = 4; $sort = 'filesize';    break;
 case 'date':        $index = 5; $sort = 'date';        break;
 case 'permissions': $index = 1; $sort = 'permissions'; break;
 case 'ownergroup':  $index = 2; $sort = 'ownergroup';  break;
}

switch (isset ($_GET['order']) ? $_GET['order'] : 'asc') {
 default:
 case 'asc':
  uasort ($sorted_list[$index], '_usort_abc');
  $order  = 'asc';
  $rorder = 'desc';
  break;
 case 'desc':
  uasort ($sorted_list[$index], '_usort_zyx');
  $order  = 'desc';
  $rorder = 'asc';
  break;
}

$querystring          = array();
$querystring['path']  = 'path='.urlencode ($pwd);
$querystring['sort']  = 'sort='.($sort);
$querystring['order'] = 'order='.($order);
$querystring[0]       = '?'.implode ('&amp;', $querystring);
$querystring[1]       = '&amp;'.substr ($querystring[0], 1);

if (isset ($_GET['file'], $_POST['change_properties']) && ($key = array_search (end (explode ('/', $_GET['file'])), $sorted_list[6])) !== false) {
 if ($_POST['filename'] != $sorted_list[6][$key]) {
  $ftp->rename ($sorted_list[6][$key], $_POST['filename']) or print ('  <div class="error">'.($ftp->get_last_response_str ()).'</div>');
  $sorted_list[6][$key] = $_POST['filename'];
 }
 
 $ftp->site ('CHMOD 0'.(int) $_POST['octal'].' '.$sorted_list[6][$key]) or print ('  <div class="error">'.($ftp->get_last_response_str ()).'</div>');
}

if (isset ($_GET['properties']) && ($key = array_search (end (explode ('/', $_GET['properties'])), $sorted_list[6])) !== false) {
 echo '  <script type="text/javascript" src="inc/permissions.js"></script>
  <script type="text/javascript">
   <![CDATA[
   function crap ( ) {
    octal = document.getElementById (\'octal\');
    octal.value = get_chmod_value (\''.$sorted_list[1][$key].'\');

    own_r = document.getElementById (\'own_r\');
    own_w = document.getElementById (\'own_w\');
    own_x = document.getElementById (\'own_x\');
    grp_r = document.getElementById (\'grp_r\');
    grp_w = document.getElementById (\'grp_w\');
    grp_x = document.getElementById (\'grp_x\');
    pub_r = document.getElementById (\'pub_r\');
    pub_w = document.getElementById (\'pub_w\');
    pub_x = document.getElementById (\'pub_x\');
   }

   function update_checkboxes ( ) {
    octal.value  = octal.value >= 0 && octal.value <= 777 ? octal.value : 0;
    owner_props  = octal.value.substr (0, 1);
    group_props  = octal.value.substr (1, 1);
    public_props = octal.value.substr (2, 1);

    own_r.checked = owner_props  & 4 ? true : false;
    own_w.checked = owner_props  & 2 ? true : false;
    own_x.checked = owner_props  & 1 ? true : false;
    grp_r.checked = group_props  & 4 ? true : false;
    grp_w.checked = group_props  & 2 ? true : false;
    grp_x.checked = group_props  & 1 ? true : false;
    pub_r.checked = public_props & 4 ? true : false;
    pub_w.checked = public_props & 2 ? true : false;
    pub_x.checked = public_props & 1 ? true : false;
   }

   function update_octal ( ) {
    var i = 0;
    i += own_r.checked ? 400 : 0;
    i += own_w.checked ? 200 : 0;
    i += own_x.checked ? 100 : 0;
    i += grp_r.checked ? 40  : 0;
    i += grp_w.checked ? 20  : 0;
    i += grp_x.checked ? 10  : 0;
    i += pub_r.checked ? 4   : 0;
    i += pub_w.checked ? 2   : 0;
    i += pub_x.checked ? 1   : 0;
    octal.value = i;
   }
   ]]>
  </script>
  <form action="',$_SERVER['PHP_SELF'], '?file=', urlencode ($_GET['properties']), $querystring[1],'" method="post">
   <table id="main">
    <thead>
     <tr>
      <th colspan="5">Change Properties for &quot;',$sorted_list[6][$key],'&quot; (',get_type ($sorted_list[1][$key]),')</th>
     </tr>
    </thead>
    <tbody>
     <tr',shade (),'>
      <td><strong>',get_type ($sorted_list[1][$key]),' name</strong></td>
      <td colspan="4"><input type="text" name="filename" size="35" value="',htmlentities ($sorted_list[6][$key]),'" /></td>
     </tr>
     <tr',shade (),'>
      <td rowspan="4"><strong>permissions</strong></td>
      <td><strong>owner</strong></td>
      <td><input type="checkbox" name="own_r" id="own_r" value="1" onchange="update_octal ();" /> <label for="own_r">read</label></td>
      <td><input type="checkbox" name="own_w" id="own_w" value="1" onchange="update_octal ();" /> <label for="own_w">write</label></td>
      <td><input type="checkbox" name="own_x" id="own_x" value="1" onchange="update_octal ();" /> <label for="own_x">execute</label></td>
     </tr>
     <tr',shade (),'>
      <td><strong>group</strong></td>
      <td><input type="checkbox" name="grp_r" id="grp_r" value="1" onchange="update_octal ();" /> <label for="grp_r">read</label></td>
      <td><input type="checkbox" name="grp_w" id="grp_w" value="1" onchange="update_octal ();" /> <label for="grp_w">write</label></td>
      <td><input type="checkbox" name="grp_x" id="grp_x" value="1" onchange="update_octal ();" /> <label for="grp_x">execute</label></td>
     </tr>
     <tr',shade (),'>
      <td><strong>public</strong></td>
      <td><input type="checkbox" name="pub_r" id="pub_r" value="1" onchange="update_octal ();" /> <label for="pub_r">read</label></td>
      <td><input type="checkbox" name="pub_w" id="pub_w" value="1" onchange="update_octal ();" /> <label for="pub_w">write</label></td>
      <td><input type="checkbox" name="pub_x" id="pub_x" value="1" onchange="update_octal ();" /> <label for="pub_x">execute</label></td>
     </tr>
     <tr',shade (),'>
      <td colspan="4">or enter octal: <input type="text" size="5" maxlength="4" name="octal" id="octal" onchange="update_checkboxes ()" value="" /></td>
     </tr>
     <tr',shade (),'>
      <td colspan="5" align="center"><input type="submit" name="change_properties" value="Change Properties" />&nbsp;<input type="submit" name="cancel" value="Cancel" /></td>
     </tr>
    </tbody>
   </table>
  </form>
  <script type="text/javascript">
   <![CDATA[
   crap ();
   update_checkboxes ();
   ]]>
  </script>';
 foot ();
}

echo '  <table id="main">
   <thead>
    <tr>
     <th colspan="3">Current Working Directory:</th>
     <th colspan="4">
      <form action="',$_SERVER['PHP_SELF'],'?',$querystring['sort'],'&amp;',$querystring['order'],'" method="get">
       <div>
        <input type="text" size="50" name="path" value="',$pwd,'" />
        <input type="submit" value="Go -&gt;" />
       </div>
      </form>
     </th>
    </tr>
   </thead>
   <tfoot>
    <tr>
     <th colspan="3">Create New Directory:</th>
     <td colspan="4"',shade (),'>
      <form action="',$_SERVER['PHP_SELF'], $querystring[0],'" method="post">
       <div>
        <input type="text" size="50" name="mkdir" value="" />
        <input type="submit" value="Make Directory" />
       </div>
      </form>
     </td>
    </tr>
    <tr>
     <th colspan="3">Upload Files:</th>
     <td colspan="4"',shade (),'>
      <form action="',$_SERVER['PHP_SELF'], $querystring[0],'" method="post" enctype="multipart/form-data">
       <div>
        <input type="hidden" name="MAX_FILE_SIZE" value="1073741824" />
        <input type="file" name="upload_1" size="30" value="" /><br />
        <input type="file" name="upload_2" size="30" value="" /><br />
        <input type="file" name="upload_3" size="30" value="" /><br />
        <input type="submit" name="upload" value="Upload Files" />
       </div>
      </form>
     </td>
    </tr>
   </tfoot>
   <tbody>
    <tr>
     <th colspan="2"><a href="',$_SERVER['PHP_SELF'],'?sort=filename&amp;order=',$sort == 'filename' ? $rorder : 'asc', '&amp;', $querystring['path'],'">Filename</a></th>
     <th><a href="',$_SERVER['PHP_SELF'],'?sort=filesize&amp;order=',$sort == 'filesize' ? $rorder : 'asc', '&amp;', $querystring['path'],'">Filesize</a></th>
     <th><a href="',$_SERVER['PHP_SELF'],'?sort=date&amp;order=',$sort == 'date' ? $rorder : 'asc', '&amp;', $querystring['path'],'">Last Modified</a></th>
     <th><a href="',$_SERVER['PHP_SELF'],'?sort=permissions&amp;order=',$sort == 'permissions' ? $rorder : 'asc', '&amp;', $querystring['path'],'">Permissions</a></th>
     <th><a href="',$_SERVER['PHP_SELF'],'?sort=ownergroup&amp;order=',$sort == 'ownergroup' ? $rorder : 'asc', '&amp;', $querystring['path'],'">Owner / Group</a></th>
     <th>Options</th>
    </tr>',$pwd != '/' ? '
    <tr>
     <td>..</td>
     <td colspan="6"><a href="'.$_SERVER['PHP_SELF'].'?path='.$pwd.urlencode ('/..').'&amp;'.$querystring['sort'].'&amp;'.$querystring['order'].'">Up One Directory</a></td>
    </tr>' : '',"\n";

foreach (array_keys ($sorted_list[$index]) as $key) {
 $dots = explode ('.', $sorted_list[6][$key]);
 switch (get_type ($sorted_list[1][$key], 1, is_array ($dots) ? end ($dots) : 0)) {
  case 'application': $img = 'binary';  break;
  case 'audio':       $img = 'audio';   break;
  case 'image':       $img = 'image';   break;
  case 'text':        $img = 'text';    break;
  case 'video':       $img = 'movie';   break;
  case 'directory':
  case 'link'     :   $img = 'menu';    break;
  case 'file':
  default:            $img = 'unknown'; break;
 }
 vprintf ('    <tr%s>
     <td><img src="img/gopher-%s.gif" alt="%s" title="%s" /></td>
     <td><a href="%s?%s=%s">%s</a></td>
     <td>%s</td>
     <td>%s</td>
     <td>%s</td>
     <td>%s %s</td>
     <td>[<a href="%s?%s=%s" title="%s">x</a>]&nbsp;[<a href="%s?properties=%s%s" title="properties">?</a>]</td>
    </tr>%c', 
          array (shade (),
                 $img,
                 $img,
                 $img,
                 $_SERVER['PHP_SELF'],
                 get_type ($sorted_list[1][$key]) == 'file' ? 'download' : 'path',
                 urlencode ($pwd.($pwd == '/' ? '' : '/').$sorted_list[6][$key]),
                 htmlentities ($sorted_list[6][$key]),
                 $sorted_list[1][$key]{0} != '-' ? '---' : format_bytes ($sorted_list[4][$key]),
                 $sorted_list[5][$key],
                 $sorted_list[1][$key],
                 htmlentities ($sorted_list[2][$key]),
                 htmlentities ($sorted_list[3][$key]),
                 $_SERVER['PHP_SELF'],
                 get_type ($sorted_list[1][$key]) == 'directory' ? 'rmd' : 'delete',
                 urlencode ($pwd.($pwd == '/' ? '' : '/').$sorted_list[6][$key]),
                 get_type ($sorted_list[1][$key]) == 'directory' ? 'remove directory' : 'delete',
                 $_SERVER['PHP_SELF'],
                 urlencode ($pwd.($pwd == '/' ? '' : '/').$sorted_list[6][$key]),
                 $querystring[1],
                 10
                )
         );
}

echo '   </tbody>
  </table>';
foot ();
